evbuffer_compat(3) | Library Functions Manual | evbuffer_compat(3)

# NAME

evbuffer_compat - Obsolete and deprecated versions of the functions in buffer.h: provided only for backward compatibility.

# SYNOPSIS

#include <event2/buffer_compat.h>
#include <event2/visibility.h>

## Macros

#define EVBUFFER_DATA(x) evbuffer_pullup((x), -1)
deprecated in favor of calling the functions directly #define EVBUFFER_LENGTH(x) evbuffer_get_length(x)
deprecated in favor of calling the functions directly

## Typedefs

typedef void(* evbuffer_cb) (struct evbuffer *buffer, size_t old_len, size_t new_len, void *arg)
Type definition for a callback that is invoked whenever data is added or removed from an evbuffer.

## Functions

EVENT2_EXPORT_SYMBOL unsigned char * evbuffer_find (struct evbuffer *buffer, const unsigned char *what, size_t len)
Find a string within an evbuffer. EVENT2_EXPORT_SYMBOL char * evbuffer_readline (struct evbuffer *buffer)
Obsolete alias for evbuffer_readln(buffer, NULL, EVBUFFER_EOL_ANY). EVENT2_EXPORT_SYMBOL void evbuffer_setcb (struct evbuffer *buffer, evbuffer_cb cb, void *cbarg)
Replace all callbacks on an evbuffer with a single new callback, or remove them.

# Detailed Description

Obsolete and deprecated versions of the functions in buffer.h: provided only for backward compatibility.

# Typedef Documentation

## typedef void(* evbuffer_cb) (struct evbuffer *buffer, size_t old_len, size_t new_len, void *arg)

Type definition for a callback that is invoked whenever data is added or removed from an evbuffer. An evbuffer may have one or more callbacks set at a time. The order in which they are executed is undefined.

A callback function may add more callbacks, or remove itself from the list of callbacks, or add or remove data from the buffer. It may not remove another callback from the list.

If a callback adds or removes data from the buffer or from another buffer, this can cause a recursive invocation of your callback or other callbacks. If you ask for an infinite loop, you might just get one: watch out!

Parameters:

buffer the buffer whose size has changed
old_len the previous length of the buffer
new_len the current length of the buffer
arg a pointer to user data

# Function Documentation

## EVENT2_EXPORT_SYMBOL unsigned char* evbuffer_find (struct evbuffer * buffer, const unsigned char * what, size_t len)

Find a string within an evbuffer.

Parameters:

buffer the evbuffer to be searched
what the string to be searched for
len the length of the search string

Returns:

a pointer to the beginning of the search string, or NULL if the search failed.

## EVENT2_EXPORT_SYMBOL char* evbuffer_readline (struct evbuffer * buffer)

Obsolete alias for evbuffer_readln(buffer, NULL, EVBUFFER_EOL_ANY).

Deprecated

This function is deprecated because its behavior is not correct for almost any protocol, and also because it's wholly subsumed by evbuffer_readln().

Parameters:

buffer the evbuffer to read from

Returns:

pointer to a single line, or NULL if an error occurred

## EVENT2_EXPORT_SYMBOL void evbuffer_setcb (struct evbuffer * buffer, evbuffer_cb cb, void * cbarg)

Replace all callbacks on an evbuffer with a single new callback, or remove them. Subsequent calls to evbuffer_setcb() replace callbacks set by previous calls. Setting the callback to NULL removes any previously set callback.

Deprecated

This function is deprecated because it clears all previous callbacks set on the evbuffer, which can cause confusing behavior if multiple parts of the code all want to add their own callbacks on a buffer. Instead, use evbuffer_add(), evbuffer_del(), and evbuffer_setflags() to manage your own evbuffer callbacks without interfering with callbacks set by others.

Parameters:

buffer the evbuffer to be monitored
cb the callback function to invoke when the evbuffer is modified, or NULL to remove all callbacks.
cbarg an argument to be provided to the callback function

# Author

Generated automatically by Doxygen for libevent from the source code.

Tue Jan 31 2017 | libevent